;
;   Random BMP Put Mini Sample by Pavlushin Evgeni for ASCL
;   www.waptap@mail.ru
;


;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     0x300000                ; memory for app
    dd     0x300000                ; esp
    dd     temp_area , 0x0         ; I_Param , I_Icon

;******************************************************************************
;5941 ;4523(with new random)



include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
    call draw_window

    loadfile '/RD/1/MFAR.BMP',I_END,temp_area
    bmptoimg I_END,img
    loadfile '/RD/1/SMILE.BMP',I_END,temp_area
    bmptoimg I_END,img2
    loadfile '/RD/1/COPY.BMP',I_END,temp_area
    bmptoimg I_END,img3

    fullimg img4 , 32 ,32 ,0x00000000   ;black

still:

    mov  eax,11                 ; scan event
    int  0x40

    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button

del_images:
    setimg dword [ply1x],dword [ply1y],img4
    setimg dword [ply2x],dword [ply2y],img4
    setimg dword [ballx],dword [bally],img4



move_images:

x_move:
    mov eax,dword [ply1rx]
    cmp dword [ply1x],eax
    je  no_m
    cmp dword [ply1x],eax
    ja  m_m
m_p:
    add dword [ply1x],1
    jmp no_m
m_m:
    sub dword [ply1x],1
no_m:


y_move:
    mov eax,dword [ply1ry]
    cmp dword [ply1y],eax
    je  no_m2
    cmp dword [ply1y],eax
    ja  m_m2
m_p2:
    add dword [ply1y],1
    jmp no_m2
m_m2:
    sub dword [ply1y],1
no_m2:


;smile runner


fx_move:
    mov eax,dword [ply1x]
    cmp dword [ply2x],eax
    je  fno_m
    cmp dword [ply2x],eax
    ja  fm_m
fm_p:
    add dword [ply2x],1
    jmp fno_m
fm_m:
    sub dword [ply2x],1
fno_m:
fy_move:
    mov eax,dword [ply1y]
    cmp dword [ply2y],eax
    je  fno_m2
    cmp dword [ply2y],eax
    ja  fm_m2
fm_p2:
    add dword [ply2y],1
    jmp fno_m2
fm_m2:
    sub dword [ply2y],1
fno_m2:


redraw_images:
    setimg dword [ply1x],dword [ply1y],img
    setimg dword [ply2x],dword [ply2y],img2 ;2
    setimg dword [ballx],dword [bally],img3

    delay 2             ;don't generate delay for fast speed programm

    jmp  still

  red:
    call draw_window
    jmp  still

  key:                          ; key
    mov eax,2
    int 0x40
    cmp ah,key_Left
    jne no_l
    sub dword [ply1rx],8
no_l:
    cmp ah,key_Right
    jne no_r
    add dword [ply1rx],8
no_r:
    cmp ah,key_Up
    jne no_u
    sub dword [ply1ry],8
no_u:
    cmp ah,key_Down
    jne no_d
    add dword [ply1ry],8
no_d:

    jmp  still

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still


draw_window:
    startwd
    window 0,0,640+8,480+24,window_Skinned
    label 12,8,'2D EXAMPLE: MOVE ICON: USE ARROW KEYS',cl_White+font_Big
;    call load_image
    endwd
    ret


; DATA AREA
xt dd 100
yt dd 100

ply1rx dd 200
ply1ry dd 50


ply1x dd 200
ply1y dd 50

ply2x dd 200
ply2y dd 400

ballx dd 200
bally dd 200

IM_END:

img:
rd 32*32*3+8
img2:
rb 32*32*3+8
img3:
rb 32*32*3+8
img4:
rb 32*32*3+8
img5:
rb 32*32*3+8

temp_area:
rb 0x15000

I_END:
